import request from './request';
import regeneratorRuntime from '@/common/static/lib/runtime';
import config from '../config.js';
import util from '../utils/util.js';

const endpoints = {
    upload: 'elab-marketing-system/behavior/brandMiniWeb/upload', //埋点接口
    login: 'elab-marketing-user/login/xcxLogin', //小程序登录接口
    brandXcxLogin: 'elab-marketing-user/applet/login', //集团小程序登录
    webXcxLogin: 'elab-marketing-user/htmlLogin/login', //H5平台小程序登录
    sign: 'elab-marketing-user/share/sign',
    signature: 'elab-marketing-user/tencent/signature',
    decrypt: 'elab-marketing-user/share/decrypt', //解密分享参数fromChannel
    detail: 'elab-marketing-user/mimiapp/parameter/detail', //获取小程序参数配置信息
    queryOnline: 'elab-marketing-content/block/queryOnline', //获取线上小程序首页数据
    imAdviserList: 'elab-marketing-user/adviser/online/im/list',
    getIpAddr: 'elab-marketing-user/ipAddr/getIpAddr',
    leavePhone: 'elab-marketing-user/brandXcx/leavePhone',
    queryMomentCurrent: 'elab-marketing-content/moment/queryMomentCurrent', //获取此时此刻当前播放内容
    modifyMomentView: 'elab-marketing-content/module/modifyMomentView', //更新此时此刻视频的观看人数
    getTDHouseList: 'elab-marketing-user/layoutVr/house', //获取3D房列表
    queryPositionHome: 'elab-marketing-content/module/queryPositionHome', //获取首页配置数据-例如：图集是否可以点击进入等后台配置内容
    queryModuleShowable: 'elab-marketing-content/module/queryModuleShowable', //检查户型和图集是否可以点击进入的查询接口
    authorizedMobile: 'elab-marketing-user/applet/auth_mobile', //解密手机号接口
    querySendCode: 'elab-marketing-user/vcode/verifyCodeForLeavePhone/send', //请求发送验证码接口
    opt: 'elab-marketing-user/vcode/verifyCode/validate', //验证码接口
    updateLike: 'elab-marketing-content/atlas/updateLike', //更新图集点赞数
    imagesListGroup: 'elab-marketing-content/atlas/listGroup', //获取图集图片列表
    listBuilding: 'elab-marketing-content/layout/listBuilding', //获取楼栋列表
    queryLayoutList: 'elab-marketing-content/layout/queryLayoutList', //获取所有户型列表
    pageListLayoutByBuilding: 'elab-marketing-content/layout/pageListLayoutByBuilding', //获取楼栋列表
    queryLayoutDetail: 'elab-marketing-content/layout/queryLayoutDetail', //查询户型详情
    successfulList: 'elab-marketing-user/brandXcx/queryRecommendList', //获取成功推荐列表
    myReport: 'elab-marketing-user/c_report/myReport', //我的报备(新版)
    visitQrCode: 'elab-marketing-user/pre3post4/visitQrCode',
    myRecommendCount: 'elab-marketing-user/count/myRecommendCount',
    getBaobeiExpand: 'elab-marketing-user/c_report/expand',
    completePhone: 'elab-marketing-user/pre3post4/completePhone',
    reportAdviserListNew: 'elab-marketing-user/bindAdviser/reportAdviserListNew',
    noticeList: 'elab-marketing-notify/customer/pageList', //获取notice信息列表
    createImages: 'elab-marketing-user/image/create', //生成分享卡片接口
    queryMomentCurrentList: 'elab-marketing-content/moment/queryMomentCurrentList', //查看更多视频
    queryWeather: 'elab-marketing-content/module/queryWeather', //查看天气
    getCityInfo: 'elab-marketing-user/house/detail', //获取项目城市信息
    getCallLog: 'elab-marketing-user/adviser/video/callLog', //获取客户是否有视频电话的权限
    queryImChatRecord: 'elab-marketing-user/adviser/text/queryImChatRecord', //获取IM消息列表数据
    validateCode: 'elab-marketing-user/vcode/login/validate', //手机验证码验证
    customerSign: 'elab-marketing-user/customer/source/sign', //客户签约
    customerVisit: 'elab-marketing-user/customer/addEcrmUser', //客户到访
    selectHouseLeadWork: 'elab-marketing-user/house/house/selectHouseLeadWork', //设置小程序顾问标语
    pushIMInfo: 'elab-marketing-notify/message/push', //IM消息通知顾问
    getCustomerDetail: 'elab-marketing-user/adviser/text/getCustomerDetail', //获取客户信息
    chatSms: 'elab-marketing-user/vcode/send/chatSms',
    connect: 'elab-marketing-user/adviser/text/connect',
    selfInfo: 'elab-marketing-user/worker/account/selfInfo',
    bindImAdviser: 'elab-marketing-user/invitation/bindImAdviser', //绑定IM顾问
    adviserInfo: 'elab-marketing-user/worker/account/adviserInfo', //获取指定顾问信息
    dialVideo: 'elab-marketing-user/adviser/dialVideo', //拨打视频通话
    submitEvaluate: 'elab-marketing-user/feedback/insertFeedback', //提交用户评价 一分钟一下以及主动挂断
    submitEvaluate2: 'elab-marketing-user/evalute/adviser/insert',
    switchStatus: 'elab-marketing-user/worker/adviser/switchStatus', //修改视频顾问的在线状态 1忙碌  0空闲
    insertData: 'elab-marketing-system/imlog/insert', //视频监控日志
    modifyUserInfo: 'elab-marketing-user/brand/modify', //修改用户个人信息
    insertFormId: 'elab-marketing-user/customer/insertFormId', //修改用户个人信息
    reportToProject: 'elab-marketing-user/invitation/recordToProject', //修改用户个人信息
    createBusinessCard: 'elab-marketing-user/image/createBusinessCard', //生成小程序分享名片
    getAutoRepeatList: 'elab-marketing-user/cQuestion/selectQuestionAndAnswer', //生成小程序分享名片
    scHouseAndBuilding4back: 'elab-wuxi-project/scHouse/scHouseAndBuilding4back', //获取销售楼栋列表
    scRoomDetailById: 'elab-wuxi-project/scRoom/detailById', //根据Id查询楼栋详情
    queryPositionPhone: 'elab-marketing-user/position/queryPositionPhone', //手机号
    tempLockRoom: 'elab-wuxi-project/scRoom/tempLockRoom', //查询锁房
    listBySCBuildingId: 'elab-wuxi-project/scFloor/listBySCBuildingId', //查询锁房
    queryEnumList: 'elab-marketing-user/enum/queryEnumList', //获取基础数据配置信息
    isAdviserInRoom: 'elab-marketing-user/app/websocket/selectStatusData',
    getPdInfo: 'elab-marketing-user/adviser/dispatchAdviser',
    updateDispatchStatus: 'elab-marketing-user/adviser/updateDispatchStatus',
    insertOrUpdate: 'elab-marketing-user/pushMessageAdviser/insertOrUpdate',
    adviserResponseTime: 'elab-marketing-user/adviser/adviserResponseTime',
    createXcxQrCode: 'elab-marketing-user/image/createXcxQrCode',
    queryViewCustomer: 'elab-marketing-user/invitation/queryViewCustomer',
    queryShareConfig: 'elab-marketing-user/mimiapp/parameter/queryShareConfig',
    queryActivity: 'elab-marketing-user/activities/queryActivity',
    queryCustomerActivity: 'elab-marketing-user/activities/queryCustomerActivity',
    addActivityRecord: 'elab-marketing-user/activities/addActivityRecord',
    editActivityRecord: 'elab-marketing-user/activities/editActivityRecord',
    questionnaireSubmit: 'elab-marketing-system/daren/insert',
    nuClearList: 'elab-marketing-user/brand/fission/pageList',
    querySearchCondition: 'elab-marketing-user/house/querySearchCondition',
    searchHouseData: 'elab-marketing-user/house/searchHouseData',
    queryXcxPage: 'elab-marketing-content/master/brandXcxPage',
    queryXcxPageNew: 'elab-marketing-content/master/brandXcxPageNew', //	小程序页面查询
    queryPageFrame: 'elab-marketing-content/frame/queryPageFrame', //	查询页面框架
    addCityHistory: 'elab-marketing-content/cityHistory/add', //	客户城市搜索记录
    selectCityHistory: 'elab-marketing-content/cityHistory/select',
    queryBrandDetail: 'elab-marketing-user/brand/queryBrandDetail', //查询品牌详情
    queryNewsByPage: 'elab-marketing-content/news/queryNewsByPage',
    queryLinkNews: 'elab-marketing-content/news/queryLinkNews',
    enterHouse: 'elab-marketing-user/applet/enter_house',
    liveTextSuspension: 'elab-marketing-file/tfk_promote/liveTextSuspension',
    houseCollection: 'elab-marketing-user/house/collection',
    collectionStatus: 'elab-marketing-user/house/collectionStatus',
    oldProprietorAutoVerifyByBrand: 'elab-marketing-user/brandXcx/oldProprietorAutoVerifyByBrand',
    drawInformationQrcode: 'elab-marketing-user/image/drawInformationQrcode',
    drawQrcode: 'elab-marketing-user/image/drawQrcode',
    drawPersonQrcode: 'elab-marketing-user/image/drawPersonQrcode',
    generateShareSign: 'elab-marketing-user/brand/shareSign/generateShareSign',
    decryptShareSign: 'elab-marketing-user/brand/shareSign/decryptShareSign',
    collection: 'elab-marketing-content/layout/collection',
    unCollection: 'elab-marketing-content/layout/unCollection',
    shareConfDetail: 'elab-marketing-content/brand/shareSetting/shareConfDetail',
    queryMyCollection: 'elab-marketing-user/house/queryMyCollection',
    queryCityData: 'elab-marketing-content/cityHistory/queryCityData',
    queryCityNews: 'elab-marketing-content/news/queryNewsByCity',
    queryNewsById: 'elab-marketing-content/news/queryNewsById',
    addCustomerCity: 'elab-marketing-content/cityHistory/addCustomerCity',
    queryPageCard: 'elab-marketing-content/house/page/queryPageCard',
    getBrandShareFriendList: 'elab-marketing-user/brandXcx/queryRecommendList',
    getLockOnDataCount: 'elab-marketing-user/brandXcx/getLookOnData',
    getLockOnCount: 'elab-marketing-user/brandXcx/getLookOnCount',
    getRecommendCount: 'elab-marketing-user/brandXcx/getRecommendCount',
    getFissionCount: 'elab-marketing-user/brandXcx/getFissionCount',
    getRecommendDynamicData: 'elab-marketing-user/brandXcx/getRecommendDynamicData',
    querySearchContent: 'elab-marketing-user/house/querySearchContent',
    searchContent: 'elab-marketing-user/house/searchContent',
    searchContentTwo: 'elab-marketing-user/house/searchContentTwo',
    houseUnCollection: 'elab-marketing-user/house/unCollection',
    addRoute: 'elab-marketing-user/customer/rules/add',
    thinkKeyword: 'elab-marketing-user/house/thinkKeyword',
    thinkKeywordTwo: 'elab-marketing-user/house/thinkKeywordTwo',
    msgSecCheck: 'elab-marketing-user/wx/msgSecCheck',
    imgSecCheck: 'elab-marketing-user/wx/imgSecCheck',
    queryCityInfo: 'elab-marketing-content/houseManagement/queryCityInfo',
    houseSort: 'elab-marketing-content/houseManagement/houseSort',
    qrCodeGetStatus: 'elab-marketing-user/qrCode/getStatus',
    visitAddVisitQueue: 'elab-marketing-user/visit/addVisitQueue',
    brandRoleEntrance: 'elab-marketing-user/organize/v2.0/verification/brandRoleEntrance',
    getAuthenticationStatusOnBrand: 'elab-marketing-user/organize/v2.0/verification/getAuthenticationStatusOnBrand',
    recommendList: 'elab-marketing-user/customerRecord/recommendList',
    record: 'elab-marketing-user/customerRecord/record',
    recordList: 'elab-marketing-user/customerRecord/recordList',
    adviserListByManualRecord: 'elab-marketing-user/customerRecord/adviserListByManualRecord',
    manualRecord: 'elab-marketing-user/c_report/manualRecord/v2',
    bindIdentity: 'elab-marketing-user/customerRecord/bindIdentity',
    noVerifiedRecommendList: 'elab-marketing-user/customerRecord/noVerifiedRecommendList',
    agentName: 'elab-marketing-user/customerRecord/agentName',
    organizeHouseInfo: 'elab-marketing-user/customerRecord/organizeHouseInfo',
    queryBindIdentityInfo: 'elab-marketing-user/customerRecord/queryBindIdentityInfo',
    entrance: 'elab-marketing-user/organize/v2.0/verification/entrance',
    verificationList: 'elab-marketing-user/organize/v2.0/verification/list',
    getAuthenticationStatus: 'elab-marketing-user/organize/v2.0/verification/getAuthenticationStatus',
    authentication: 'elab-marketing-user/organize/v2.0/verification/authentication',
    authenticationByBrand: 'elab-marketing-user/organize/v2.0/verification/authenticationByBrand',
    resetAuthentication: 'elab-marketing-user/organize/v2.0/verification/resetAuthentication',
    autoAuthentication: 'elab-marketing-user/organize/v2.0/verification/autoAuthentication',
    synchronousVerificationBetweenBrandHouses: 'elab-marketing-user/organize/v2.0/verification/synchronousVerificationBetweenBrandHouses',
    organizeInfoByBrand: 'elab-marketing-user/customerRecord/organizeInfoByBrand',
    manualReportOnBrand: 'elab-marketing-user/brandXcx/manualReportOnBrand',
    manualReportOnBrandNew: 'elab-marketing-user/brandXcx/manualReportOnBrandNew',
    validate: 'elab-marketing-user/vcode/verifyCode/validate',
    getVideoChatCount: 'elab-marketing-content/house/video/videoHouseCount',
    brandCustomerBehaviorRecording: 'elab-marketing-user/adviser/online/video/brandCustomerBehaviorRecording',
    getOrganizeUserByMobile: 'elab-marketing-user/organize/v2.0/members/getOrganizeUserByMobile',
    relationNetwork: 'elab-marketing-user/invitation/relationNetwork',
    getUserScoreCount: 'elab-marketing-user/integrals/userinfo/getUserScoreCount',
    getScoreListDetail: 'elab-marketing-user/integrals/userinfo/list',
    getUnReadObject: 'elab-marketing-user/integrals/userinfo/getUnReadObject',
    getScoreRuleList: 'elab-marketing-user/integrals/rule/list',
    intergralShare: 'elab-marketing-user/integrals/userinfo/share',
    authenticationTicketNo: 'elab-marketing-user/zhidi/activity/authenticationTicketNo',
    getUserMobile: 'elab-marketing-user/zhidi/activity/getUserMobile',
    shareActivity: 'elab-marketing-user/zhidi/activity/shareActivity',
    actionVerification: 'elab-marketing-content/miniAction/actionVerification',
    getProjectGUIDByHouseId: 'elab-marketing-user/projectManage/getProjectGUIDByHouseId',
    getUserMobileNew: 'elab-marketing-user/zhidi/activity/getUserMobileNew',
    toExchange: 'elab-marketing-user/product/config/exchange',
    getExcableList: 'elab-marketing-user/product/config/excableList',
    getTicketList: 'elab-marketing-user/zhidi/ticket/list',
    activitySignIn: 'elab-marketing-user/zhidi/activity/signIn',
    twiceReport: 'elab-marketing-user/twiceReport/twiceReportNew',
    maxRecordTip: 'elab-marketing-user/customerRecord/maxRecordTip',
    assignAdviserList: 'elab-marketing-user/bindAdviser/assignAdviserList',
    chooseAdviser: 'elab-marketing-user/bindAdviser/bind',
    unBindCheeseAdviser: 'elab-marketing-user/bindAdviser/unbind',
    reportType: 'elab-marketing-user/pre3post4/reportType',
    reportByPre3Post4: 'elab-marketing-user/pre3post4/reportByPre3Post4/v2',
    authentication4Zd: 'elab-marketing-user/organize/v2.0/verification/authentication4Zd',
    authenticationByBrand4Zd: 'elab-marketing-user/organize/v2.0/verification/authenticationByBrand4Zd',
    resetAuthentication4Zd: 'elab-marketing-user/organize/v2.0/verification/resetAuthentication4Zd',
    getLivingRoomList: 'elab-marketing-user/liveRoom/mini/list',
	getNewLivingRoomListNew: 'elab-marketing-user/liveRoom/liveLikeList',
    getNewLivingRoomList: 'elab-marketing-user/liveRoom/live/list',
    getNewLivingRoomDetail: 'elab-marketing-user/liveRoom/detailNew',
    getRecordRoomList: 'elab-marketing-user/liveRoom/vod/list',
    turntableActivity: 'elab-marketing-user/zhidi/activity/concurrent/turntableActivity',
    prizesList: 'elab-marketing-user/zhidi/activity/prizesList',
    getObjectByIdForActive: 'elab-marketing-user/zhidi/info/getObjectById',
    activityRegistration: 'elab-marketing-user/zhidi/activity/concurrent/activityRegistration',
    register: 'elab-marketing-user/zhidi/99buyHouse/register',
    hasVerification: 'elab-marketing-user/zhidi/99buyHouse/hasVerification',
    getCommonVerifyCode: 'elab-marketing-user/vcode/send/verifyCode',
    getNewOpenHouse: 'elab-marketing-content/houseManagement/getNewOpenHouse',
    recommendCities: 'elab-marketing-content/houseManagement/recommendCities',
    selectRoomOnline: 'elab-marketing-content/houseManagement/selectRoomOnline',
    recommendCityList: 'elab-marketing-user/adviser/online/video/recommendCityList',
    countForRecommendAdviser: 'elab-marketing-user/adviser/online/video/countForRecommendAdviser',
    getHouseAddress: 'elab-marketing-content/houseManagement/getHouseAddress',
    onlineHouseDetailById: 'elab-marketing-content/soRoom/detailById',
    thumbsUp: 'elab-marketing-content/soRoom/thumbsUp',
    thumbsUpRoomList: 'elab-marketing-content/soRoom/thumbsUpRoomList',
    getSoHouseDetailById: 'elab-marketing-content/soHouse/detailById',
    getSoBuildingListAll: 'elab-marketing-content/soBuilding/listAll',
    getSoRoomUnitList: 'elab-marketing-content/soRoom/unitList',
    getSoRoomPageList: 'elab-marketing-content/soRoom/pageList',
    getRoomPageList: 'elab-marketing-content/zhuangHu/roomList',
    earthAndFormat: 'elab-marketing-content/zhuangHu/earthAndFormat',
    onlineHouseLeavePhone: 'elab-marketing-content/leavePhone/add',
    detailByName: 'elab-marketing-content/soCopyWriting/detailByName',
    addOrder: 'elab-marketing-content/zhuangHu/addOrder',
    orderDetail: 'elab-marketing-content/zhuangHu/orderDetail',
    ZHorderList: 'elab-marketing-content/zhuangHu/orderList',
    payOrder: 'elab-marketing-content/zhuangHu/payOrder',
    payOrder2: 'elab-marketing-content/wx/native/unifiedOrder',
    orderNotice: 'elab-marketing-content/zhuangHu/orderNotice',
    createOrder: 'elab-marketing-content/soOrder/insert',
    queryOrderDetailById: 'elab-marketing-content/soOrder/detailById',
    getSoOrderListByCustomerId: 'elab-marketing-content/soOrder/listByCustomerId',
    getSoOrderOrderRecordList: 'elab-marketing-content/soOrder/orderRecordList',
    downloadPayProof: 'elab-marketing-content/zhuangHu/downloadPayProof',
    querySubscribeStatus: 'elab-marketing-user/templateMessage/querySubscribeStatus',
    subscribe: 'elab-marketing-user/templateMessage/subscribe',
    activityDetail: 'elab-marketing-content/activityInfo/activityDetail',
    pageDetail: 'elab-marketing-content/activityInfo/pageDetail',
    getMyWorkList: 'elab-marketing-user/activityProduction/myProduction',
    getAllWorkList: 'elab-marketing-user/activityProduction/allProduction',
    subPageList: 'elab-marketing-content/activityInfo/subPageList',
    likeWork: 'elab-marketing-user/activityProduction/like',
    activityHouseRank: 'elab-marketing-user/activityProduction/houseRank',
    activityHouseList: 'elab-marketing-content/activityInfo/activityHouseList',
    getShareHouse: 'elab-marketing-user/activityProduction/shareProductionInfo',
    activityApplay: 'elab-marketing-user/activityProduction/apply',
    activityAuthentication: 'elab-marketing-user/activityProduction/authentication',
    createQRCode: 'elab-marketing-user/zhidi/ticket/createQRCode',
    proprietorApplyEntrance: 'elab-marketing-user/activityProduction/proprietorApplyEntrance',
    publishProduction: 'elab-marketing-user/activityProduction/publishProduction',
    applyOrNot: 'elab-marketing-user/activityProduction/applyOrNot',
    openShareActivity: 'elab-marketing-user/activityProduction/openShareActivity',
    productionIsCheckPass: 'elab-marketing-user/activityProduction/productionIsCheckPass',
    queryAllHouseByBrandId: 'elab-marketing-user/brandHouseRelate/queryAllHouseByBrandId',
    sharePrize: 'elab-marketing-user/zhidi/99buyHouse/share',
    dealPrize: 'elab-marketing-user/zhidi/99buyHouse/deal',
    visitPrize: 'elab-marketing-user/zhidi/99buyHouse/visit',
    realTimeRanking: 'elab-marketing-user/activityProduction/realTimeRanking',
    drawPersonQrcodeInHouse: 'elab-marketing-user/image/houseShareCodeOnBrand',
    myRecommend: 'elab-marketing-user/report/upgrade/myRecommend',
    myRecommendv2: 'elab-marketing-user/report/upgrade/myRecommend/v2',
    recommendCount: 'elab-marketing-user/report/upgrade/recommendCount',
    newMyReport: 'elab-marketing-user/report/upgrade/myReport/v3',
    myReportRecord: 'elab-marketing-user/report/upgrade/myReportRecord',
    reportCountPlus: 'elab-marketing-user/report/upgrade/reportCount/v3',
    reportCount: 'elab-marketing-user/report/upgrade/reportCount',
    recommendHouseList: 'elab-marketing-user/report/upgrade/recommendHouseList',
    reReport: 'elab-marketing-user/report/upgrade/reReport',
    editUserInfo: 'elab-marketing-user/report/upgrade/editUserInfo',
    reportHouseList: 'elab-marketing-user/report/upgrade/reportHouseList',
    userInfoDetail: 'elab-marketing-user/zhiDiUser/userInfoDetail',
    userReportDetail: 'elab-marketing-user/zhiDiUser/userReportDetail',
    queryBrandAuthenticationInfo: 'elab-marketing-user/customerRecord/queryBrandAuthenticationInfo',
    photoActivityTime: 'elab-marketing-user/activityProduction/activityProductionTime',
    photoCreatorRank: 'elab-marketing-user/activityProduction/photographerRank', //	摄影师排行
    queryPhotoCreatorInfo: 'elab-marketing-user/activityProduction/photographerPersonalInformation', //	作者个人中心信息
    queryPhotoCreatorProduct: 'elab-marketing-user/activityProduction/photographerProductionList', //	单个作者作品
    queryCustomerBankInfoByUserId: 'elab-marketing-content/customerBank/queryCustomerBankInfoByUserId', //根据id查询用户银行信息
    bindBankInfo: 'elab-marketing-content/customerBank/bindBankInfo', //绑定银行信息
    updateBankInfo: 'elab-marketing-content/customerBank/updateBankInfo', //修改银行信息
    findCityList: 'elab-marketing-content/CityManagement/findCityList', //城市列表
    queryVideoHouseList: 'elab-marketing-content/brandVideo/queryVideoHouseList',
    selectLotMatchingByhouseIdOrTitle: 'elab-marketing-system/lotMatchingService/selectLotMatchingByhouseIdOrTitle', //根据组件id查询关联项目
    queryGenList: 'elab-marketing-content/productJen/queryGenList',
    listLayoutInfo: 'elab-marketing-content/layout/listLayoutInfo', //获取项目主推户型
    busCommercial: 'elab-marketing-content/mortgageCalculator/busCommercial', //房贷计算器计算接口
    initialization: 'elab-marketing-content/mortgageCalculator/initialization', //房贷计算器初始化配置
    monthlyDetail: 'elab-marketing-content/mortgageCalculator/monthlyDetail', //月供明细
    intelligentRecommendationPage: 'elab-marketing-content/materialLabel/intelligentRecommendationPage', //智能推荐，千人前面
    houseQueryById: 'elab-marketing-content/mortgageCalculator/houseQueryById', //查询项目所在城市
    queryKjlLayoutList: 'elab-xiaomai-analyse/kjl/houseList', //查询酷家乐关联户型列表
    getKjlHouseTypeDetail: 'elab-xiaomai-analyse/kjl/houseMessage', //查询酷家乐关联户型列表
    getVirtualPhone: 'elab-xiaomai-analyse/kjl/getVirtualPhone', //查询酷家乐关联顾问信息
    getVrToken: 'elab-xiaomai-analyse/kjl/getVrToken', //查询酷家乐关联顾问信息
    queryByActivityIdForHelp: 'elab-marketing-content/phase/award/queryByActivityId', //查询助力组件信息
    queryOneById: 'elab-marketing-content/partake/log/queryOneById', //根据活动id和用户id查询
    queryByPartakeUserId: 'elab-marketing-content/ranking/queryByPartakeUserId', //查询参与活动详情
    queryRankByActivityId: 'elab-marketing-content/ranking/award/queryRankByActivityId', //根据活动id查询
    getVoucherForHelp: 'elab-marketing-content/ranking/rewarding', //助力活动领奖
    findHouseByAlbum: 'elab-marketing-content/atlas/findHouseByAlbum', //查询相册数量以及第一张图片
    selectProjectParamsNew: 'elab-marketing-content/houseManagement/selectParamsNew', //查询当前项目信息
    getObjectByIdNew: 'elab-marketing-user/zhidi/info/getObjectByIdNew', //查询单个置地活动表对象
    querySubscribeNewStatus: 'elab-marketing-user/templateMessage/querySubscribeNewStatus', //查询消息订阅状态（多条）
    subscribeNew: 'elab-marketing-user/templateMessage/subscribeNew', //消息订阅（新）
    getOneById: 'elab-marketing-content/question/getOneById', //查询题目
    addAnswerSheet: 'elab-marketing-content/examination/addAnswerSheet', //用户提交问卷
    getExaminationByPageId: 'elab-marketing-content/examination/getExaminationByPageId', //用户提交问卷
    findByUserIdAndActivityId: 'elab-marketing-content/examination/findByUserIdAndActivityId', //根据用户id活动id查询问卷
    newFindUserFollow: 'elab-marketing-user/c_follow/newFindUserFollow', //查询跟进记录
    automaticBinding: 'elab-marketing-user/imVideoVr/automaticBinding', //查询酷家乐关联顾问信息
    send: 'elab-marketing-user/vcode/userMerge/send', //发送短信验证码
    authUserMergeByVerificationCode: 'elab-marketing-user/userMerge/authUserMergeByVerificationCode', //用户合并接口
    queryUserMobileAuth: 'elab-marketing-user/userMerge/queryUserMobileAuth', //查询是否清空手机号
    roleExplain: 'elab-marketing-user/organize/v2.0/verification/roleExplain', //查询角色文案是否开启
    getDetailInfo: 'elab-marketing-user/report/upgrade/myReport/detail', //查询单个用户信息
    addHelpLog: 'elab-marketing-content/help/log/addHelpLog', //新增用户助力表,
    checkUserJoinStatusForHelp: 'elab-marketing-content/partake/log/queryOneById', //根据活动id和用户id查询用户是否已参与助力活动
    addPartakeLog: 'elab-marketing-content/partake/log/addPartakeLog', //新增用户参与表
    pageFindRank: 'elab-marketing-content/ranking/pageFindRank',
    queryOnlineCityConfig: 'elab-marketing-user/brandStyle/getConfigByBrandId',
    queryCityDetail: 'elab-marketing-content/houseManagement/cityDetail', //排名列表
    newHouseSort: 'elab-marketing-content/houseManagement/newHouseSort', //项目观看人数等接口
    applet_failed: 'elab-marketing-user/report/wait_confirm/applet_failed', //小程序报备失败台账
    applet: 'elab-marketing-user/report/wait_confirm/applet', //小程序待确认台账
    app_retry: 'elab-marketing-user/report/wait_confirm/app_retry', //小程序待确认台账
    wait_confirmList: 'elab-marketing-user/business_notify/wait_confirm/list', //待确认通知列表接口
    searchContentTwoNew: 'elab-marketing-content/house/searchContentThree',//新版搜索接口
    searchHouseDataNew: 'elab-marketing-content/house/searchHouseDataThree', //新版按类别查询接口
    newAuthentication4Zd: 'elab-marketing-user/organize/v2.0/verification/newAuthentication4Zd', //置地老业主认证-城市认证
    checkValid: 'elab-marketing-user/qrCode/checkValid', //置地老业主认证-城市认证
    houseActivityDetail:'elab-marketing-content/zhuangHu/houseActivityDetail',  //查询装户活动信息
    checkRoomStatus:'elab-marketing-content/wx/zhuanghu',  //查询装户活动信息
    querySubscribeLiveStatus:'elab-marketing-user/templateMessage/querySubscribeLiveStatus', //置地老业主认证-城市认证
    queryTemplateLiveList:'elab-marketing-user/templateMessage/queryTemplateLiveList', //置地老业主认证-城市认证
    subscribeByLive:'elab-marketing-user/templateMessage/subscribeByLive', //置地老业主认证-城市认证
    layoutByBrandList:'elab-marketing-content/layout/layoutByBrandList', //置地老业主认证-城市认证
    liveStreamList:'elab-marketing-user/liveRoom/liveStreamList', //直播流列表
    userOuponInfo:'elab-marketing-user/tfl/userOuponInfo', //查询用户卡卷详情

    getObjectByList:'elab-marketing-user/ticket/wraps/getObjectByList', //查询卡券包集合数据
    getObjectById:'elab-marketing-user/ticket/wraps/getObjectById', //查询卡券包集合数据
    assessFlag:'elab-marketing-user/assess/assessFlag', //根据活动判断是否可以评论
    commentsInsert: "elab-marketing-user/assess/insert",  //添加评论
    listComments: "elab-marketing-user/assess/list",  //查询评论列表

    unifiedOrder: 'elab-marketing-content/wx/general/unifiedOrder',//微信支付-小程序-统一下单(通用版)
    selectByOrder: 'elab-marketing-content/wx/selectByOrder',//微信支付-小程序-查询订单(通用版)
    liveSuspension:'elab-marketing-user/liveRoom/liveSuspension', //直播入口悬浮球
    anchorSave:'elab-marketing-file/tfk_promote/save', //添加主播认证
    anchorInfo:'elab-marketing-file/tfk_promote/anchorInfo', //查询单条主播信息
    wholeCount:'elab-marketing-analyse/tfk/wholeCount', //淘房客整体统计
    xcxAmount:'elab-marketing-analyse/tfk/xcxAmount', //淘房客整体统计
    queryAllEnumByType:'elab-marketing-file/tfk_promote/queryAllEnumByType', //查询主播标签
    queryCityListByPid:'elab-marketing-file/tfk_promote/queryCityListByPid', //查询城市列表
    findCityListByTree:'elab-marketing-file/tfk_promote/findCityListByTree', //查询城市列表
    xcxAuthProtocol: 'elab-marketing-user/enum/xcxAuthProtocol',//小程序授权协议
    encodeInsert: 'elab-marketing-content/lay_in/insert',//数据存储【添加】
    decodeQuery: 'elab-marketing-content/lay_in/queryOneById',//数据存储【根据id查询】
    createGroup: 'elab-marketing-sms/im/createGroup',//创建群组
    destroyGroup: 'elab-marketing-sms/im/destroyGroup',//解散群组
    deleteGroupMember: 'elab-marketing-sms/im/deleteGroupMember',//删除群成员
    queryByComponentId: 'elab-marketing-content/clocked_in/applet/activity/info',//小程序端获取活动信息
    qrClockedCode: 'elab-marketing-content/clocked_in/qr_code',//生成打卡二维码
    treatyInfo: 'elab-marketing-user/customerRecord/treatyInfo',  //报备协议详情
};
var doubleClickList = [];
export default async (endpoint, options, isHideLoading = null, preventDoubleClick = false) => {
    var app = getApp();
    if (!endpoints.hasOwnProperty(endpoint)) {
        console.error(`no such endpoint: ${endpoint}`);
        return {
            message: "不存在该接口"
        };
    }
    if(endpoint.indexOf('queryUserMobileAuth')==-1
    && endpoint.indexOf('upload')==-1
    && endpoint.indexOf('brandXcxLogin')==-1){
        app && app.queryUserMobileAuth();//除了以上接口，其他接口发送之前都需要检查下是否需要清空手机号
    }
    let encryptedData = '';
    // const requestOptions = endpoints[endpoint].call(null, options);
    const requestOptions = {
        path: endpoints[endpoint],
        data: options,
        method: "POST",
    };
    if (requestOptions.data) {
        requestOptions.data.terminal = (app && app.globalData) ? app.globalData.terminal : "1";
    }
    if (endpoint.indexOf('authorizedMobile') >= 0 || endpoint.indexOf('enterHouse') >= 0 || endpoint.indexOf(
            'brandXcxLogin') >= 0) {
        encryptedData = await util.AES_encrypt(requestOptions.data);
        requestOptions.data = {};
        
    }
    if (preventDoubleClick) {
        //说明该接口需要防止连击
        if (doubleClickList[requestOptions.path] && doubleClickList[requestOptions.path].isRunning) {
            console.log(`${requestOptions.path}触发连击，屏蔽该请求`)

            return
        } else {
            console.log(`${requestOptions.path}触发连击，通过`)
            doubleClickList[requestOptions.path] = {
                isRunning: true
            }
        }
    }
    console.log(`获取${requestOptions.path}请求的参数:`, requestOptions.data)
    requestOptions.url = config.newUrl + requestOptions.path;
    requestOptions.header = {
        xcx_token: (app && app.globalData && app.globalData.xcx_token) || '',
        elabBrandId: config.brandId,
        elabProjectName: config.projectEngName || '',
        elabSystem: 2,
        customerId: (app && app.globalData && app.globalData.single && app.globalData.single.id) ? app
            .globalData
            .single.id : '',
        elabEnvironment: 3,
        'content-type': 'application/json;charset=UTF-8', // 默认值
        'tonken': (app && app.globalData && app.globalData.tonken) ? app.globalData.tonken : "",
    };
    if (encryptedData) {
        requestOptions.header.sign = encryptedData;
    }
    try {
        if (requestOptions.data && requestOptions.data.md && typeof requestOptions.data.md == 'object') {
            let currPage = getCurrentPages()[getCurrentPages().length - 1] ? getCurrentPages()[getCurrentPages()
                    .length -
                    1].$vm :
                null;
            var _route = currPage ? (currPage.route || currPage.__route__ || "") : "";
            let MustO = { //必传参数
                user_id: (app && app.globalData.single && app.globalData.single.id) ? app.globalData.single.id :
                    '',
                brand_id: config.brandId,
                house_id: (currPage && currPage.houseId ? currPage.houseId : ''),
                pagePath: _route,
                session_id: (app && app.globalData.session_id) || ''
            }
            Object.assign(MustO, requestOptions.data.md);
            Object.assign(requestOptions.header, MustO);
            requestOptions.data.md = null;
        }
        requestOptions.data = JSON.stringify(requestOptions.data)
    } catch (e) {
        console.log(e, 'eeeeeeeeeeeee')
    }
    var t = Math.round(new Date());
    requestOptions.time = t;
    const response = await request(requestOptions, isHideLoading);
    //说明该接口需要防止连击
    if (preventDoubleClick && doubleClickList[requestOptions.path] && doubleClickList[requestOptions.path]
        .isRunning) {
        console.log(`${requestOptions.path}连击接口已返回，清空连击数组`)
        doubleClickList[requestOptions.path].isRunning = false
    }

    console.log('返回' + requestOptions.path + '请求的结果:', response)
    // console.log({ url: requestOptions.url, req: requestOptions, res: response });
    return response;
}
